%bcond_with jp_minimal

Name:                freemarker
Version:             2.3.32
Release:             1
Summary:             The Apache FreeMarker Template Engine
License:             ASL 2.0
URL:                 https://freemarker.apache.org/
Source0:             https://github.com/apache/incubator-freemarker/archive/v%{version}/%{name}-%{version}.tar.gz
Patch1:              jsp-api.patch
Patch2:              jython-compatibility.patch
Patch3:              fix-javadoc-encoding.patch
Patch5:              no-javarebel.patch
Patch6:              enable-jdom.patch
Patch7:              javacc-7.patch
Patch8:              freemarker-2.3.31-use-jakarta-el.patch

BuildArch:           noarch
BuildRequires:       java-1.8.0-openjdk-devel ant apache-parent apache-commons-logging aqute-bnd hamcrest
BuildRequires:       ivy-local glassfish-jsp-api glassfish-servlet-api javacc >= 7.0 jaxen >= 1.1
BuildRequires:       jcl-over-slf4j jdom >= 1.0 junit log4j-over-slf4j slf4j
BuildRequires:       xalan-j2 >= 2.7.0
BuildRequires:       jakarta-el >= 4.0.0

%if %{without jp_minimal}
BuildRequires:       dom4j
BuildRequires:       saxpath
BuildRequires:       jython
BuildRequires:       rhino >= 1.6
%endif

%description
Apache FreeMarker is a template engine: a Java library to generate text output
(HTML web pages, e-mails, configuration files, source code, etc.) based on
templates and changing data. Templates are written in the FreeMarker Template
Language (FTL), which is a simple, specialized language (not a full-blown
programming language like PHP).

%package help
Summary:             Javadoc for %{name}
Provides:            %{name}-javadoc = %{version}-%{release}
Obsoletes:           %{name}-javadoc < %{version}-%{release}
%description help
This package contains the API documentation for %{name}.

%prep
%setup -q
find -type f -name "*.jar" -delete
find -type f -name "*.class" -delete
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

rm ivysettings.xml
sed -i 's/cachepath conf="IDE"/cachepath conf="javadoc"/' build.xml
sed -i '/conf name="IDE"/i<conf name="javadoc" extends="build.jython2.5,build.jsp2.1" />' ivy.xml
sed -i -e '/avalon-logkit/d' ivy.xml
rm src/main/java/freemarker/log/_AvalonLoggerFactory.java

%if %{with jp_minimal}
sed -i -e '/"rhino"/d' -e '/"jython"/d' ivy.xml
rm -rf src/main/java/freemarker/ext/{rhino,jython,ant}
rm src/main/ava/freemarker/template/utility/JythonRuntime.java
sed -i -e '/dom4j/d' -e '/saxpath/d' ivy.xml
rm src/main/java/freemarker/ext/xml/_Dom4jNavigator.java
%endif

sed -i -e '/^Import-Package/s/:/: !org.apache.log4j, /' osgi.bnd
%mvn_file org.%{name}:%{name} %{name}

%build
export LANG=C.UTF-8
export JAVA_HOME=%{_jvmdir}/java-1.8.0
ant -Divy.mode=local -Ddeps.available=true javacc jar javadoc maven-pom

%install
export LANG=C.UTF-8
%mvn_artifact build/pom.xml build/%{name}.jar
%mvn_install -J build/api

%files -f .mfiles
%doc README.md RELEASE-NOTES
%license LICENSE NOTICE

%files help -f .mfiles-javadoc
%license LICENSE NOTICE

%changelog
* Wed Jul 26 2023 xu_ping <707078654@qq.com> - 2.3.32-1
- Update version to 2.3.32

* Tue Apr 18 2023 Dongxing Wang <dxwangk@isoftstone.com> - 2.3.31-2
- Update jakarta-el to 4.0.0

* Wed Jun 01 2022 xigaoxinyan <xigaoxinyan@h-partners.com> - 2.3.31-1
- Update to 2.3.31

* Mon Aug 24 2020 liyanan <liyanan32@huawei.com> - 2.3.28-1
- package init
